// CLuceneTestDlg.cpp : implementation file
//

#include "stdafx.h"

#include "CLuceneTest.h"
#include "CLuceneTestDlg.h"
#include "IndexAndSearch.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCLuceneTestDlg dialog

CCLuceneTestDlg::CCLuceneTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCLuceneTestDlg::IDD, pParent)
	, m_bSrcChanged(true)
{
	//{{AFX_DATA_INIT(CCLuceneTestDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CCLuceneTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCLuceneTestDlg)
	DDX_Control(pDX, IDC_QUERY, m_cQuery);
	DDX_Control(pDX, IDC_SEARCHRESULT, m_cSearchResult);
	DDX_Control(pDX, IDC_SRC, m_cSrc);
	//}}AFX_DATA_MAP

	m_cSrc.SetWindowText("hahaha ѱ۴ܾ hohoho  bye ˻\r\n"
		"hello zaza ѱ   Ǹ ˻\r\n"
		"goodbye Ǹ  ˻  SGʺ");

}

BEGIN_MESSAGE_MAP(CCLuceneTestDlg, CDialog)
	//{{AFX_MSG_MAP(CCLuceneTestDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDOK, OnOk)
	ON_BN_CLICKED(IDC_SEARCHBUTTON, OnSearchButton)
	ON_EN_CHANGE(IDC_SRC, OnChangeSrc)
	ON_EN_CHANGE(IDC_QUERY, OnChangeQuery)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCLuceneTestDlg message handlers

BOOL CCLuceneTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CCLuceneTestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CCLuceneTestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CCLuceneTestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CCLuceneTestDlg::OnOk() 
{
}

void CCLuceneTestDlg::OnSearchButton() 
{
	const char *indexpath="./indexdir";

	if (m_bSrcChanged) {
		CString src;
		m_cSrc.GetWindowText(src);
		IndexDocs(indexpath, src.GetBuffer(0));
		m_bSrcChanged = false;
	}
	CString query;
	m_cQuery.GetWindowText(query);
	string ret = SearchDocs(indexpath, query.GetBuffer(0));	

	m_cSearchResult.SetWindowText(ret.c_str());
}

void CCLuceneTestDlg::OnChangeSrc() 
{
	m_bSrcChanged = true;
}

void CCLuceneTestDlg::OnChangeQuery() 
{
	CString query;
	m_cQuery.GetWindowText(query);

	if (query.IsEmpty()) {
		GetDlgItem(IDC_SEARCHBUTTON)->EnableWindow(FALSE);
	} else {
		GetDlgItem(IDC_SEARCHBUTTON)->EnableWindow(TRUE);
	}
	
}
